org.bouncycastle.crypto.digests

## Class SHA384Digest

- java.lang.Object
- - org.bouncycastle.crypto.digests.LongDigest
  - - org.bouncycastle.crypto.digests.SHA384Digest

- All Implemented Interfaces:
    Digest, EncodableDigest, EncodableService, ExtendedDigest, Memoable

      public class SHA384Digest
      extends LongDigest

  FIPS 180-2 implementation of SHA-384.

               block  word  digest
       SHA-1   512    32    160
       SHA-256 512    32    256
       SHA-384 1024   64    384
       SHA-512 1024   64    512

- - ### Field Summary

    - ### Fields inherited from class org.bouncycastle.crypto.digests.LongDigest

      `H1, H2, H3, H4, H5, H6, H7, H8, purpose`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SHA384Digest()` Standard constructor
    `SHA384Digest(byte[] encodedState)` State constructor - create a digest initialised with the state of a previous one.
    `SHA384Digest(CryptoServicePurpose purpose)` Standard constructor, with purpose
    `SHA384Digest(SHA384Digest t)` Copy constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Memoable` | `copy()` Produce a copy of this object with its configuration and in its current state.
    `protected CryptoServiceProperties` | `cryptoServiceProperties()`
    `int` | `doFinal(byte[] out, int outOff)` close the digest, producing the final digest value.
    `java.lang.String` | `getAlgorithmName()` return the algorithm name
    `int` | `getDigestSize()` return the size, in bytes, of the digest produced by this message digest.
    `byte[]` | `getEncodedState()` Return an encoded byte array for the digest's internal state
    `void` | `reset()` reset the chaining variables
    `void` | `reset(Memoable other)` Restore a copied object state into this object.

    - ### Methods inherited from class org.bouncycastle.crypto.digests.LongDigest

      `copyIn, finish, getByteLength, getEncodedStateSize, populateState, processBlock, processLength, processWord, restoreState, update, update`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SHA384Digest

          public SHA384Digest()

      Standard constructor

    - #### SHA384Digest

          public SHA384Digest(CryptoServicePurpose purpose)

      Standard constructor, with purpose

    - #### SHA384Digest

          public SHA384Digest(SHA384Digest t)

      Copy constructor. This will copy the state of the provided message digest.

    - #### SHA384Digest

          public SHA384Digest(byte[] encodedState)

      State constructor - create a digest initialised with the state of a previous one.
      Parameters:
        `encodedState` - the encoded state from the originating digest.

  - ### Method Detail

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Description copied from interface: `Digest`
      return the algorithm name
      Returns:
        the algorithm name

    - #### getDigestSize

          public int getDigestSize()

      Description copied from interface: `Digest`
      return the size, in bytes, of the digest produced by this message digest.
      Returns:
        the size, in bytes, of the digest produced by this message digest.

    - #### doFinal

          public int doFinal(byte[] out,
                             int outOff)

      Description copied from interface: `Digest`
      close the digest, producing the final digest value. The doFinal call leaves the digest reset.
      Parameters:
        `out` - the array the digest is to be copied into.
        `outOff` - the offset into the out array the digest is to start at.

    - #### reset

          public void reset()

      reset the chaining variables
      Specified by:
        `reset` in interface `Digest`
      Overrides:
        `reset` in class `LongDigest`

    - #### copy

          public Memoable copy()

      Description copied from interface: `Memoable`
      Produce a copy of this object with its configuration and in its current state.

      The returned object may be used simply to store the state, or may be used as a similar object starting from the copied state.

    - #### reset

          public void reset(Memoable other)

      Description copied from interface: `Memoable`
      Restore a copied object state into this object.

      Implementations of this method should try to avoid or minimise memory allocation to perform the reset.

      Parameters:
        `other` - an object originally `copied` from an object of the same type as this instance.

    - #### getEncodedState

          public byte[] getEncodedState()

      Description copied from interface: `EncodableDigest`
      Return an encoded byte array for the digest's internal state
      Returns:
        an encoding of the digests internal state.

    - #### cryptoServiceProperties

          protected CryptoServiceProperties cryptoServiceProperties()

      Specified by:
        `cryptoServiceProperties` in class `LongDigest`